#include "MPlayerNoise.h"


MPlayerNoise::MPlayerNoise(PClip _child, int _StrengthY, int _StrengthUV, IScriptEnvironment* env) : GenericVideoFilter(_child), StrengthY(_StrengthY), StrengthUV(_StrengthUV) {

	memset(&fpy, 0, sizeof(FilterParam));
	fpy.strength = StrengthY;
	fpy.temporal = 1;

	memcpy(&fpu, &fpy, sizeof(FilterParam));
	fpu.strength = StrengthUV;

	memcpy(&fpv, &fpy, sizeof(FilterParam));
	fpv.strength = StrengthUV;

	mp_noise_init(&fpy);
	mp_noise_init(&fpu);
	mp_noise_init(&fpv);
}


MPlayerNoise::~MPlayerNoise() {
	mp_noise_done(&fpy);
	mp_noise_done(&fpu);
	mp_noise_done(&fpv);
}




PVideoFrame __stdcall MPlayerNoise::GetFrame(int n, IScriptEnvironment* env) {
	PVideoFrame src = child->GetFrame(n, env);
	PVideoFrame dst = env->NewVideoFrame(vi);

	if (vi.IsYV12()) {
		mp_noise_process(src->GetReadPtr(PLANAR_Y), dst->GetWritePtr(PLANAR_Y), dst->GetPitch(PLANAR_Y), src->GetPitch(PLANAR_Y), dst->GetRowSize(PLANAR_Y), dst->GetHeight(PLANAR_Y), &fpy);
		mp_noise_process(src->GetReadPtr(PLANAR_U), dst->GetWritePtr(PLANAR_U), dst->GetPitch(PLANAR_U), src->GetPitch(PLANAR_U), dst->GetRowSize(PLANAR_U), dst->GetHeight(PLANAR_U), &fpu);
		mp_noise_process(src->GetReadPtr(PLANAR_V), dst->GetWritePtr(PLANAR_V), dst->GetPitch(PLANAR_V), src->GetPitch(PLANAR_V), dst->GetRowSize(PLANAR_V), dst->GetHeight(PLANAR_V), &fpv);
	} else {
		env->ThrowError("MPlayerNoise only supports YV12 colorspace");
	}

	return dst;
}




