#ifndef _VF_NOISE_H_
#define _VF_NOISE_H_

#ifdef __cplusplus
extern "C" {
#endif

#define MAX_NOISE 4096
#define MAX_SHIFT 1024
#define MAX_RES (MAX_NOISE-MAX_SHIFT)

typedef struct FilterParam
{
 int strength;
 int uniform;
 int temporal;
 int quality;
 int averaged;
 int pattern;
 int shiftptr;
 char *noise;
 char *prev_shift[MAX_RES][3];
} FilterParam;

void mp_noise_(void);
char *mp_noise_init(FilterParam *fp);
void mp_noise_done(FilterParam *fp);
void mp_noise_process(const unsigned char *src, unsigned char *dst, int dstStride, int srcStride, int width, int height, FilterParam *fp);

#ifdef __cplusplus
}
#endif

#endif
